--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_pkt.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_pkt.c	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,1038 @@
+/* name: mausb_pkt.c 
+ * description: MA USB packet helper functions 
+ * 
+ * This file is provided under a dual BSD/GPLv2 license. When using or 
+ * redistributing this file, you may do so under either license. 
+ * 
+ * GPL LICENSE SUMMARY 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * This program is free software; you can redistribute it and/or modify it 
+ * under the terms of version 2 of the GNU General Public License as published 
+ * by the Free Software Foundation. 
+ * 
+ * This program is distributed in the hope that it will be useful, but 
+ * WITHOUT ANY WARRANTY; without even the implied warranty of 
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
+ * General Public License for more details. 
+ * 
+ * Contact Information: 
+ * Sean Stalley, sean.stalley [at] intel 
+ * Stephanie Wallick, stephanie.s.wallick [at] intel 
+ * 2111 NE 25th Avenue 
+ * Hillsboro, Oregon 97124 
+ * 
+ * BSD LICENSE 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * Redistribution and use in source and binary forms, with or without 
+ * modification, are permitted provided that the following conditions 
+ * are met: 
+ * 
+ * Redistributions of source code must retain the above copyright 
+ notice, this list of conditions and the following disclaimer. 
+ * Redistributions in binary form must reproduce the above copyright 
+ notice, this list of conditions and the following disclaimer in 
+ the documentation and/or other materials provided with the 
+ distribution. 
+ * Neither the name of Intel Corporation nor the names of its 
+ contributors may be used to endorse or promote products derived 
+ from this software without specific prior written permission. 
+ 
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
+ * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
+ * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
+ * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
+ * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
+ * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
+ */ 
+ 
+#include <linux/slab.h> 
+#include <linux/usb/ch9.h> 
+#include <linux/usb.h> 
+ 
+#include "mausb_mem.h" 
+#include "mausb_pkt.h" 
+#include "mausb_const.h" 
+ 
+/** 
+ * Translates numerical packet type into corresponding string (for printing). 
+ */ 
+const char *mausb_type_to_string(enum mausb_pkt_type type) 
+{ 
+ switch (type) { 
+ case CapReq: 
+ return "CapReq"; 
+ case CapResp: 
+ return "CapResp"; 
+ case USBDevHandleReq: 
+ return "USBDevHandleReq"; 
+ case USBDevHandleResp: 
+ return "USBDevHandleResp"; 
+ case EPHandleReq: 
+ return "EPHandleReq"; 
+ case EPHandleResp: 
+ return "EPHandleResp"; 
+ case EPActivateReq: 
+ return "EPActivateReq"; 
+ case EPActivateResp: 
+ return "EPActivateResp"; 
+ case EPInactivateReq: 
+ return "EPInactivateReq"; 
+ case EPInactivateResp: 
+ return "EPInactivateResp"; 
+ case EPResetReq: 
+ return "EPResetReq"; 
+ case EPResetResp: 
+ return "EPResetResp"; 
+ case EPClearTransferReq: 
+ return "EPClearTransferReq"; 
+ case EPClearTransferResp: 
+ return "EPClearTransferResp"; 
+ case EPHandleDeleteReq: 
+ return "EPHandleDeleteReq"; 
+ case EPHandleDeleteResp: 
+ return "EPHandleDeleteResp"; 
+ case DevResetReq: 
+ return "DevResetReq"; 
+ case DevResetResp: 
+ return "DevResetResp"; 
+ case ModifyEP0Req: 
+ return "ModifyEP0Req"; 
+ case ModifyEP0Resp: 
+ return "ModifyEP0Resp"; 
+ case SetUSBDevAddrReq: 
+ return "SetUSBDevAddrReq"; 
+ case SetUSBDevAddrResp: 
+ return "SetUSBDevAddrResp"; 
+ case UpdateDevReq: 
+ return "UpdateDevReq"; 
+ case UpdateDevResp: 
+ return "UpdateDevResp"; 
+ case USBDevDisconnectReq: 
+ return "USBDevDisconnectReq"; 
+ case USBDevDisconnectResp: 
+ return "USBDevDisconnectResp"; 
+ case USBSuspendReq: 
+ return "USBSuspendReq"; 
+ case USBSuspendResp: 
+ return "USBSuspendResp"; 
+ case USBResumeReq: 
+ return "USBResumeReq"; 
+ case USBResumeResp: 
+ return "USBResumeResp"; 
+ case RemoteWakeReq: 
+ return "RemoteWakeReq"; 
+ case RemoteWakeResp: 
+ return "RemoteWakeResp"; 
+ case PingReq: 
+ return "PingReq"; 
+ case PingResp: 
+ return "PingResp"; 
+ case DevDisconnectReq: 
+ return "DevDisconnectReq"; 
+ case DevDisconnectResp: 
+ return "DevDisconnectResp"; 
+ case DevInitDisconnectReq: 
+ return "DevInitDisconnectReq"; 
+ case DevInitDisconnectResp: 
+ return "DevInitDisconnectResp"; 
+ case SyncReq: 
+ return "SyncReq"; 
+ case SyncResp: 
+ return "SyncResp"; 
+ case CancelTransferReq: 
+ return "CancelTransferReq"; 
+ case CancelTransferResp: 
+ return "CancelTransferResp"; 
+ case EPOpenStreamReq: 
+ return "EPOpenStreamReq"; 
+ case EPOpenStreamResp: 
+ return "EPOpenStreamResp"; 
+ case EPCloseStreamReq: 
+ return "EPCloseStreamReq"; 
+ case EPCloseStreamResp: 
+ return "EPCloseStreamResp"; 
+ case USBDevResetReq: 
+ return "USBDevResetReq"; 
+ case USBDevResetResp: 
+ return "USBDevResetResp"; 
+ case DevNotificationReq: 
+ return "DevNotificationReq"; 
+ case DevNotificationResp: 
+ return "DevNotificationResp"; 
+ case EPSetKeepAliveReq: 
+ return "EPSetKeepAliveReq"; 
+ case EPSetKeepAliveResp: 
+ return "EPSetKeepAliveResp"; 
+ case GetPortBWReq: 
+ return "GetPortBWReq"; 
+ case GetPortBWResp: 
+ return "GetPortBWResp"; 
+ case SleepReq: 
+ return "SleepReq"; 
+ case SleepResp: 
+ return "SleepResp"; 
+ case WakeReq: 
+ return "WakeReq"; 
+ case WakeResp: 
+ return "WakeResp"; 
+ case VendorSpecificReq: 
+ return "VendorSpecificReq"; 
+ case VendorSpecificResp: 
+ return "VendorSpecificResp"; 
+ case TransferSetupReq: 
+ return "TransferSetupReq"; 
+ case TransferSetupResp: 
+ return "TransferSetupResp"; 
+ case TransferTearDownConf: 
+ return "TransferTearDownConf"; 
+ case TransferReq: 
+ return "TransferReq"; 
+ case TransferResp: 
+ return "TransferResp"; 
+ case TransferAck: 
+ return "TransferAck"; 
+ case IsochTransferReq: 
+ return "IsochTransferReq"; 
+ case IsochTransferResp: 
+ return "IsochTransferResp"; 
+ } 
+ 
+ return "unknown"; 
+} 
+EXPORT_SYMBOL(mausb_type_to_string); 
+ 
+/** 
+ * Translates a negative errno to a MAUSB status. Returns a packet status value. 
+ */ 
+enum mausb_pkt_status mausb_errno_to_ma_status(int errno) 
+{ 
+ switch (errno) { 
+ case 0: /* no error */ 
+ return SUCCESS; 
+ case -EINPROGRESS: 
+ return TRANSFER_PENDING; 
+ case -ESTRPIPE: 
+ return TRANSFER_EP_STALL; 
+ /* TODO: map all relevant ma status' */ 
+ default: 
+ return UNSUCCESSFUL; 
+ } /* end switch */ 
+ 
+} 
+EXPORT_SYMBOL(mausb_errno_to_ma_status); 
+ 
+/** 
+ * Translates an URB status to a MAUSB status 
+ */ 
+int mausb_to_urb_status(enum mausb_pkt_status pkt_status) 
+{ 
+ switch (pkt_status) { 
+ case SUCCESS: /* no error */ 
+ return 0; 
+ case TRANSFER_PENDING: 
+ return -EINPROGRESS; 
+ case TRANSFER_EP_STALL: 
+ return -ESTRPIPE; 
+ /* TODO: map all relevant urb statuses */ 
+ default: 
+ return -EIO; /* generic I/O error */ 
+ } /* end switch */ 
+ 
+} 
+EXPORT_SYMBOL(mausb_to_urb_status); 
+ 
+/** 
+ * Determines if the packet is a response packet. Returns true if the packet is 
+ * a response packet. Returns false otherwise. 
+ */ 
+bool mausb_pkt_resp(struct mausb_pkt *pkt) 
+{ 
+ return pkt->common->pkt_type & MAUSB_PKT_RESP_FLAG; 
+} 
+ 
+/** 
+ * Determines if a given packet is a management packet. 
+ */ 
+static bool mausb_pkt_is_mgmt(struct mausb_pkt_common *common) 
+{ 
+ if ((common->pkt_type & MAUSB_PKT_TYPE_MASK) == MAUSB_PKT_TYPE_MGMT) 
+ return true; 
+ else 
+ return false; 
+} 
+ 
+ 
+/** 
+ * Returns the sum of the sequnce number & the value added. Handles sequence 
+ * number wraparound. 
+ */ 
+u32 mausb_seq_num_add(u32 seq_num, int val) 
+{ 
+ return (seq_num + val) % (MAUSB_MAX_SEQ_NUM + 1); 
+} 
+EXPORT_SYMBOL(mausb_seq_num_add); 
+ 
+/** 
+ * Increments a sequence number value by one. 
+ */ 
+void mausb_increment_seq_num(u32 *seq_num) 
+{ 
+ *seq_num = mausb_seq_num_add(*seq_num, 1); 
+} 
+ 
+/** 
+ * Compares two sequence numbers. Returns true if a is less than b. 
+ * Handles sequence number wraparound. 
+ */ 
+bool mausb_seq_num_lt(u32 a, u32 b) 
+{ 
+ 
+ if (a > MAUSB_MAX_SEQ_NUM || b > MAUSB_MAX_SEQ_NUM) { 
+ mapkt_warn("%s: input out of range\n", __func__); 
+ return false; 
+ } 
+ 
+ if (b < MAUSB_HALF_SEQ_NUM) { /* b is in the lower half */ 
+ 
+ if ((b > a) || ((b + MAUSB_HALF_SEQ_NUM) < a)) 
+ return true; 
+ else 
+ return false; 
+ 
+ } else { /* b is in the upper half */ 
+ 
+ if ((b > a) && (b - MAUSB_HALF_SEQ_NUM) < a) 
+ return true; 
+ else 
+ return false; 
+ } 
+ 
+ /* we should never get here */ 
+ BUG(); 
+ return false; 
+} 
+EXPORT_SYMBOL(mausb_seq_num_lt); 
+ 
+/** 
+ * Sequence number less than or equal to. 
+ */ 
+bool mausb_seq_num_lt_eq(u32 a, u32 b) 
+{ 
+ return mausb_seq_num_lt(b, a) ? false : true; 
+} 
+ 
+/** 
+ * Sequence number greater than or equal to. 
+ */ 
+bool mausb_seq_num_gt_eq(u32 a, u32 b) 
+{ 
+ return mausb_seq_num_lt(a, b) ? false : true; 
+} 
+ 
+/** 
+ * Sequence number greater than. 
+ */ 
+bool mausb_seq_num_gt(u32 a, u32 b) 
+{ 
+ return mausb_seq_num_lt(b, a); 
+} 
+EXPORT_SYMBOL(mausb_seq_num_gt); 
+ 
+/** 
+ * Returns the sum of the request id and the value added. Handles request id 
+ * wraparound. 
+ */ 
+u8 mausb_req_id_add(u8 req_id, int val) 
+{ 
+ return (req_id + val) % (MAUSB_MAX_REQ_ID + 1); 
+} 
+EXPORT_SYMBOL(mausb_req_id_add); 
+ 
+/** 
+ * Compares 2 request IDs. Returns true if a is less than b. Handles request id 
+ * wraparound. 
+ */ 
+bool mausb_req_id_lt(u8 a, u8 b) 
+{ 
+ 
+ if (a > MAUSB_MAX_REQ_ID || b > MAUSB_MAX_REQ_ID) { 
+ mapkt_warn("%s: input out of range\n", __func__); 
+ return false; 
+ } 
+ 
+ if (b < MAUSB_HALF_REQ_ID) { /* b is in the lower half */ 
+ 
+ if ((b > a) || ((b + MAUSB_HALF_REQ_ID) < a)) 
+ return true; 
+ else 
+ return false; 
+ 
+ } else { /* b is in the upper half */ 
+ 
+ if ((b > a) && (b - MAUSB_HALF_REQ_ID) < a) 
+ return true; 
+ else 
+ return false; 
+ } 
+ 
+ /* we should never get here */ 
+ BUG(); 
+ return false; 
+} 
+EXPORT_SYMBOL(mausb_req_id_lt); 
+ 
+bool mausb_req_id_gt(u8 a, u8 b) 
+{ 
+ return mausb_req_id_lt(b, a); 
+} 
+ 
+bool mausb_req_id_gt_eq(u8 a, u8 b) 
+{ 
+ return mausb_req_id_lt(a, b) ? false : true; 
+} 
+EXPORT_SYMBOL(mausb_req_id_gt_eq); 
+ 
+/** 
+ * Finds an endpoint descriptor inside of an endpoint handle request 
+ */ 
+struct usb_endpoint_descriptor *mausb_ep_handle_req_get_ep_des( 
+ struct mausb_EPHandleReq_flds *req, int i) 
+{ 
+ 
+ if (i >= le32_to_cpu(req->num_ep_des)) { 
+ mapkt_warn("%s: endpoint descriptor not in packet\n", __func__); 
+ return NULL; 
+ } 
+ 
+ if (MAUSB_EP_REQ_SIZE == le32_to_cpu(req->size_ep_des)) { 
+ return (struct usb_endpoint_descriptor *) 
+ &req->ep_des[i].ep_des; 
+ 
+ } else if (MAUSB_SS_EP_REQ_SIZE == le32_to_cpu(req->size_ep_des)) { 
+ return (struct usb_endpoint_descriptor *) 
+ &req->ss_ep_des[i].ep_des; 
+ 
+ } else { 
+ mapkt_err("%s: unsupported size_ep_des value (%u)\n", 
+ __func__, le32_to_cpu(req->size_ep_des)); 
+ } 
+ 
+ return NULL; 
+} 
+EXPORT_SYMBOL(mausb_ep_handle_req_get_ep_des); 
+ 
+static struct mausb_pkt_common *mausb_header_from_ms_pkt(struct ms_pkt *pkt) 
+{ 
+ struct mausb_pkt_common *header; 
+ 
+ if (pkt->kvec[0].iov_len < sizeof(*header)) { 
+ mapkt_err("%s: first entry too small for header\n", __func__); 
+ header = NULL; 
+ } else 
+ header = pkt->kvec[0].iov_base; 
+ 
+ return header; 
+} 
+ 
+/** 
+ * Accepts an MA USB packet for the MA device and forwards it to the correct 
+ * handler based on packet type and endpoint/device handle. 
+ */ 
+int mausb_pkt_dmux(struct ms_pkt *pkt, void *context) 
+{ 
+ int ret = -EINVAL; 
+ struct mausb_pkt_common *header = mausb_header_from_ms_pkt(pkt); 
+ struct ma_dev *ma_dev = context_to_ma_dev(context); 
+ struct mausb_host_ep *ma_ep = NULL; 
+ struct mausb_pkt_transfer *transfer = NULL; 
+ 
+ if (mausb_pkt_is_mgmt(header)) { 
+ transfer = &ma_dev->mgmt.tx_pair.to_ma; 
+ 
+ } else { 
+ /* otherwise, find the endpoint it belongs to */ 
+ ma_ep = mausb_find_ep_from_handle(header->ep_handle, 
+ ma_dev); 
+ 
+ if (NULL != ma_ep) 
+ transfer = &ma_ep->tx_pair.to_ma; 
+ } 
+ 
+ if (NULL != transfer) 
+ ret = transfer->transfer_packet(pkt, transfer->context); 
+ 
+ return ret; 
+} 
+ 
+/** 
+ * Packet destructor for packets generated by the MA driver. For packets that we 
+ * have created, we want to free the header but not the data buffers (since the 
+ * buffers belong to the URB). 
+ */ 
+static void mausb_pkt_destructor(struct ms_pkt *ms_pkt) 
+{ 
+ struct mausb_pkt *ma_pkt = ms_pkt_to_mausb_pkt(ms_pkt); 
+ 
+ kfree(ma_pkt->common); 
+ 
+ return; 
+} 
+ 
+/** 
+ * Allocates space for given packet type. 
+ */ 
+struct mausb_pkt *mausb_alloc_pkt(enum mausb_pkt_type pkt_type, int *status, 
+ gfp_t memflags) 
+{ 
+ int size; 
+ int ret = 0; 
+ struct mausb_pkt *pkt; 
+ 
+ /* determine header length */ 
+ switch (pkt_type & MAUSB_PKT_TYPE_MASK) { 
+ 
+ case MAUSB_PKT_TYPE_MGMT: 
+ size = sizeof(struct mausb_mgmt_pkt); 
+ break; 
+ case MAUSB_PKT_TYPE_CTRL: 
+ size = sizeof(struct mausb_ctrl_pkt); 
+ break; 
+ case MAUSB_PKT_TYPE_DATA: 
+ size = sizeof(struct mausb_iso_dph); 
+ break; 
+ default: 
+ mapkt_err("%s: could not determine packet type\n", __func__); 
+ if (NULL != status) 
+ *status = -EINVAL; 
+ return NULL; 
+ } 
+ 
+ pkt = kzalloc(sizeof(struct mausb_pkt), memflags); 
+ if (NULL == pkt) { 
+ ret = -ENOMEM; 
+ pkt = NULL; 
+ } else { 
+ pkt->common = kzalloc(size, memflags); 
+ if (NULL == pkt->common) { 
+ mapkt_err("could not allocate memory for MA USB" 
+ " packet header of length %i\n", size); 
+ kfree(pkt); 
+ ret = -ENOMEM; 
+ pkt = NULL; 
+ } 
+ 
+ pkt->ms_pkt_destructor = &mausb_pkt_destructor; 
+ pkt->orig_pkt = &pkt->pkt; 
+ } 
+ 
+ if (NULL != status) 
+ *status = ret; 
+ 
+ return pkt; 
+} 
+ 
+/** 
+ * Deletes the given data packet 
+ */ 
+void mausb_free_pkt(struct mausb_pkt *pkt) 
+{ 
+ /* kill the buffers (when necessary) */ 
+ pkt->ms_pkt_destructor(pkt->orig_pkt); 
+ kfree(pkt); 
+} 
+EXPORT_SYMBOL(mausb_free_pkt); 
+ 
+/** 
+ * Returns the length of the header or a negative errno. 
+ */ 
+int mausb_pkt_header_length(struct mausb_pkt_common *header) 
+{ 
+ int length; 
+ 
+ switch (header->pkt_type & MAUSB_PKT_TYPE_MASK) { 
+ 
+ case MAUSB_PKT_TYPE_MGMT: 
+ case MAUSB_PKT_TYPE_CTRL: 
+ length = le16_to_cpu(header->length); 
+ break; 
+ case MAUSB_PKT_TYPE_DATA: 
+ length = sizeof(struct mausb_dph); 
+ break; 
+ default: 
+ mapkt_err("%s:invalid packet type\n", __func__); 
+ length = -EINVAL; 
+ break; 
+ } 
+ 
+ return length; 
+} 
+EXPORT_SYMBOL(mausb_pkt_header_length); 
+ 
+/** 
+ * Returns a pointer to a buffer of specified length that is 
+ * found offset a given number of bytes into the ms_pkt. 
+ * 
+ * If a contigious buffer can be found, this function returns 
+ * the virtual address of this buffer. otherwise, it returns null 
+ */ 
+static void *mausb_get_buf_from_ms_pkt(struct ms_pkt *pkt, 
+ int offset, int buf_length) 
+{ 
+ int i; 
+ int page_offset = offset; 
+ char *ret = NULL; 
+ struct kvec *current_kvec; 
+ 
+ for (i = 0; i < pkt->nents; ++i) { 
+ current_kvec = &pkt->kvec[i]; 
+ 
+ /* if the buffer is in this kvec entry */ 
+ if (page_offset < current_kvec->iov_len) { 
+ 
+ /* and the whole buffer is in current_kvec */ 
+ if (page_offset + buf_length <= current_kvec->iov_len) { 
+ ret = (char *) current_kvec->iov_base; 
+ ret += page_offset; 
+ } 
+ 
+ return ret; 
+ } 
+ 
+ page_offset -= current_kvec->iov_len; 
+ } 
+ 
+ if (0 != page_offset) { 
+ mapkt_err("%s: offset of %i Bytes is greater than packet" 
+ " length\n", __func__, page_offset); 
+ } 
+ return NULL; 
+} 
+ 
+bool mausb_pkt_has_setup_data(struct mausb_dph *header) 
+{ 
+ /* 
+ * Only control transfer requests with sequence number 0 should have 
+ * setup data - nothing else should ever carry setup data. 
+ */ 
+ if (header->common.pkt_type == TransferReq) { 
+ if ((header->eps_tflags & MAUSB_PKT_TFLAG_TYPE_MASK) 
+ == MAUSB_PKT_TFLAG_TYPE_CTRL 
+ && le32_to_cpu(header->seq_num) == 0) 
+ return true; 
+ } 
+ 
+ return false; 
+} 
+EXPORT_SYMBOL(mausb_pkt_has_setup_data); 
+ 
+/** 
+ * Gets an mausb_pkt structure from a given ms_pkt structure. 
+ * 
+ * can only be used if this driver created the packet i.e. if you just received 
+ * an ms_pkt from another machine, it will not be part of a mausb_pkt. 
+ */ 
+struct mausb_pkt *ms_pkt_to_mausb_pkt(struct ms_pkt *ms_pkt) 
+{ 
+ return container_of(ms_pkt, struct mausb_pkt, pkt); 
+} 
+ 
+/** 
+ * Creates a mausb_pkt structure from a given ms_pkt structure. Used for parsing 
+ * incoming packets. 
+ */ 
+struct mausb_pkt *mausb_pkt_from_ms_pkt(struct ms_pkt *ms_pkt, 
+ void (*ms_pkt_destructor)(struct ms_pkt *ms_pkt), gfp_t mem_flags) 
+{ 
+ struct mausb_pkt *pkt; 
+ int current_offset; 
+ int packet_length; 
+ 
+ pkt = kzalloc(sizeof(struct mausb_pkt), mem_flags); 
+ if (NULL == pkt) 
+ return NULL; 
+ 
+ pkt->pkt = *ms_pkt; 
+ pkt->orig_pkt = ms_pkt; 
+ pkt->ms_pkt_destructor = ms_pkt_destructor; 
+ 
+ /* the first portion is always the header */ 
+ pkt->common = mausb_header_from_ms_pkt(ms_pkt); 
+ current_offset = mausb_pkt_header_length(pkt->common); 
+ packet_length = pkt->common->length; 
+ 
+ /* checks to see if header is contigious */ 
+ if (NULL == mausb_get_buf_from_ms_pkt(ms_pkt, 0, current_offset)) { 
+ 
+ mapkt_err("%s: packet header bigger than entry (header is %i" 
+ " bytes)\n", __func__, current_offset); 
+ kfree(pkt); 
+ return NULL; 
+ } 
+ 
+ /* 
+ * NOTE: Currently control and management packets must be contigious. 
+ * data packet headers must also be contigious. 
+ * (ie: the data must all be in 1 ms_pkt entry). 
+ * 
+ * TODO: handle when a control/management is in more than 1 
+ * kvec entry 
+ */ 
+ 
+ if (MAUSB_PKT_TYPE_DATA == 
+ (pkt->common->pkt_type & MAUSB_PKT_TYPE_MASK)) { 
+ 
+ if (mausb_pkt_has_setup_data(pkt->data)) { 
+ pkt->setup = mausb_get_buf_from_ms_pkt(ms_pkt, 
+ current_offset, sizeof(*pkt->setup)); 
+ 
+ if (NULL == pkt->setup) { 
+ mapkt_err("%s: could not get setup data\n", 
+ __func__); 
+ } else { 
+ current_offset += sizeof(*pkt->setup); 
+ } 
+ } 
+ 
+ if (packet_length > current_offset) { 
+ pkt->buffer = mausb_get_buf_from_ms_pkt(ms_pkt, 
+ current_offset, packet_length - current_offset); 
+ 
+ /* 
+ * if the remaining data was contigious, treat it as a 
+ * buffer 
+ */ 
+ if (NULL != pkt->buffer) { 
+ pkt->buffer_length = 
+ packet_length - current_offset; 
+ current_offset += pkt->buffer_length; 
+ } 
+ 
+ } else if (packet_length < current_offset) { 
+ mapkt_dbg("%s: packet_length:%i, current_offset:%i\n", 
+ __func__, packet_length, current_offset); 
+ } 
+ } 
+ 
+ /* checks to see if there is data after packet */ 
+ if (NULL != mausb_get_buf_from_ms_pkt(ms_pkt, current_offset, 0)) 
+ mapkt_warn("%s: Warning: data exists after packet\n", __func__); 
+ 
+ return pkt; 
+ 
+} 
+EXPORT_SYMBOL(mausb_pkt_from_ms_pkt); 
+ 
+/** 
+ * Fills the ms_pkt of a given mausb_pkt based on fields in the mausb_pkt struct. 
+ */ 
+int mausb_pkt_fill_ms_pkt(struct mausb_pkt *pkt, gfp_t mem_flags) 
+{ 
+ struct ms_pkt *ms_pkt = &pkt->pkt; 
+ unsigned int ent_length; 
+ 
+ ms_pkt->nents = 0; 
+ 
+ if (NULL != pkt->common) { 
+ /* add the header */ 
+ ent_length = mausb_pkt_header_length(pkt->common); 
+ if (0 >= ent_length) { 
+ return -EINVAL; 
+ } 
+ 
+ } else { /* We should ALWAYS have a header, and we dont... */ 
+ mapkt_err("%s: header not found\n", __func__); 
+ return -EINVAL; 
+ } 
+ 
+ ms_pkt->kvec[ms_pkt->nents].iov_base = pkt->common; 
+ ms_pkt->kvec[ms_pkt->nents].iov_len = ent_length; 
+ ms_pkt->nents += 1; 
+ 
+ /* If this packet should have data, send it */ 
+ if (pkt->common->pkt_type == TransferReq || 
+ pkt->common->pkt_type == TransferResp){ 
+ 
+ /* add the setup field */ 
+ if (mausb_pkt_has_setup_data(pkt->data)) { 
+ ms_pkt->kvec[ms_pkt->nents].iov_base = pkt->setup; 
+ ms_pkt->kvec[ms_pkt->nents].iov_len = 
+ sizeof(*pkt->setup); 
+ ms_pkt->nents += 1; 
+ 
+ } else if (NULL != pkt->setup) { 
+ mapkt_warn("%s: Warning: packet has Setup field, but " 
+ "flags in header are not set\n", __func__); 
+ } 
+ 
+ if (NULL != pkt->buffer && pkt->nents > 0) { 
+ mapkt_err("%s: packet has scatterlist and databuffer\n" 
+ , __func__); 
+ return -EINVAL; 
+ } 
+ 
+ /* add the data buffer */ 
+ if (NULL != pkt->buffer) { 
+ ms_pkt->kvec[ms_pkt->nents].iov_base = pkt->buffer; 
+ ms_pkt->kvec[ms_pkt->nents].iov_len = 
+ pkt->buffer_length; 
+ ms_pkt->nents += 1; 
+ } 
+ } 
+ 
+ mapkt_dbg("%s: pkt filled with %i entries\n", __func__, ms_pkt->nents); 
+ 
+ return 0; 
+} 
+ 
+/** 
+ * Calculates the total length of data contained in an ms_pkt (in bytes). 
+ * Returns the length of the kvec, or 0 on an error. 
+ */ 
+static int mausb_ms_data_length(struct ms_pkt *pkt) 
+{ 
+ int i; 
+ int total_length; 
+ struct kvec *current_kvec; 
+ 
+ for (i = 0; i < pkt->nents; ++i) { 
+ current_kvec = &pkt->kvec[i]; 
+ if (NULL == current_kvec) 
+ return -EINVAL; 
+ else 
+ total_length += current_kvec->iov_len; 
+ } 
+ 
+ return total_length; 
+} 
+ 
+/** 
+ * Calculates the length of the datafield in a given datapacket. 
+ */ 
+static int mausb_pkt_datafield_length(struct mausb_pkt *pkt) 
+{ 
+ int length = 0; 
+ 
+ if (NULL != pkt->buffer) 
+ length += pkt->buffer_length; 
+ if (0 != pkt->nents) 
+ length += mausb_ms_data_length(&pkt->pkt); 
+ 
+ return length; 
+} 
+ 
+/** 
+ * Parses the packet fields to determine how long the packet is. Returns the 
+ * packet length on sucess, or a negative errno on error. 
+ */ 
+int mausb_pkt_length(struct mausb_pkt *pkt) 
+{ 
+ int length; 
+ 
+ /* all packets have this field */ 
+ switch (pkt->common->pkt_type & MAUSB_PKT_TYPE_MASK) { 
+ 
+ /* Management packets */ 
+ case MAUSB_PKT_TYPE_MGMT: 
+ length = sizeof(*pkt->common); 
+ length += MAUSB_MGMT_TOKEN_PAD_LEN; 
+ 
+ /* subtypes without additional data */ 
+ switch (pkt->common->pkt_type) { 
+ case DevResetReq: 
+ case DevResetResp: 
+ case UpdateDevResp: 
+ case DevDisconnectReq: 
+ case DevDisconnectResp: 
+ case USBDevDisconnectReq: 
+ case USBDevDisconnectResp: 
+ case SleepReq: 
+ case SleepResp: 
+ case WakeReq: 
+ case WakeResp: 
+ case RemoteWakeReq: 
+ case RemoteWakeResp: 
+ case PingReq: 
+ case PingResp: 
+ case DevInitDisconnectReq: 
+ case DevInitDisconnectResp: 
+ case SyncResp: 
+ break; 
+ 
+ /* subtypes with constant length additional data */ 
+ case CapReq: 
+ length += sizeof(pkt->mgmt->cap_req); 
+ break; 
+ case CapResp: 
+ length += sizeof(pkt->mgmt->cap_resp); 
+ /* also include length of any descriptors */ 
+ length += pkt->mgmt->cap_resp.desc_length; 
+ break; 
+ case USBDevHandleReq: 
+ length += sizeof(pkt->mgmt->usb_dev_handle_req); 
+ break; 
+ case USBDevHandleResp: 
+ length += sizeof(pkt->mgmt->usb_dev_handle_resp); 
+ break; 
+ case ModifyEP0Req: 
+ length += sizeof(pkt->mgmt->modify_ep0_req); 
+ break; 
+ case ModifyEP0Resp: 
+ length += sizeof(pkt->mgmt->modify_ep0_resp); 
+ break; 
+ case SetUSBDevAddrReq: 
+ length += sizeof(pkt->mgmt->set_dev_addr_req); 
+ break; 
+ case SetUSBDevAddrResp: 
+ length += sizeof(pkt->mgmt->set_dev_addr_resp); 
+ break; 
+ case UpdateDevReq: 
+ length += sizeof(pkt->mgmt->update_dev_req); 
+ break; 
+ case SyncReq: 
+ length += sizeof(pkt->mgmt->synch_req); 
+ break; 
+ case EPCloseStreamReq: 
+ length += sizeof(pkt->mgmt->ep_close_stream_req); 
+ break; 
+ case CancelTransferReq: 
+ length += sizeof(pkt->mgmt->cancel_transfer_req); 
+ break; 
+ case CancelTransferResp: 
+ length += sizeof(pkt->mgmt->cancel_transfer_resp); 
+ break; 
+ case EPOpenStreamReq: 
+ length += sizeof(pkt->mgmt->ep_open_stream_req); 
+ break; 
+ /* subtypes with variable length additional data */ 
+ case EPHandleReq: 
+ length += sizeof(__u32); 
+ length += pkt->mgmt->ep_handle_req.num_ep_des * 
+ pkt->mgmt->ep_handle_req.size_ep_des; 
+ break; 
+ case EPHandleResp: 
+ length += sizeof(__u32); 
+ length += pkt->mgmt->ep_handle_resp.num_ep_des * 
+ sizeof(struct mausb_ep_des); 
+ break; 
+ case EPActivateReq: 
+ case EPActivateResp: 
+ case EPInactivateReq: 
+ case EPInactivateResp: 
+ case EPResetReq: 
+ case EPResetResp: 
+ case EPClearTransferReq: 
+ case EPClearTransferResp: 
+ case EPHandleDeleteReq: /* FALLTHROUGH */ 
+ case EPHandleDeleteResp: 
+ length += sizeof(__u32); 
+ length += pkt->mgmt->ep_handle_delete.num_ep 
+ * sizeof(struct mausb_ep_handle); 
+ break; 
+ case EPCloseStreamResp: 
+ case USBDevResetReq: 
+ case USBDevResetResp: 
+ case EPOpenStreamResp: 
+ case VendorSpecificReq: 
+ case VendorSpecificResp: 
+ mapkt_err("%s: cannot determine length of %s packet -" 
+ " packet type not yet handled\n", __func__, 
+ mausb_type_to_string(pkt->common->pkt_type)); 
+ BUG(); 
+ break; 
+ default: 
+ mapkt_err("%s: invalid management packet type %x\n", 
+ __func__, pkt->common->pkt_type); 
+ BUG(); 
+ break; 
+ } 
+ 
+ break; 
+ 
+ /* Control Packets */ 
+ case MAUSB_PKT_TYPE_CTRL: 
+ length = sizeof(struct mausb_ctrl_pkt); 
+ switch (pkt->common->pkt_type) { 
+ case TransferSetupReq: 
+ length += sizeof(struct mausb_TransferSetupReq_flds); 
+ break; 
+ case TransferSetupResp: 
+ break; 
+ case TransferTearDownConf: 
+ break; 
+ default: 
+ mapkt_err("%s: invalid control packet type %x\n", 
+ __func__, pkt->common->pkt_type); 
+ BUG(); 
+ break; 
+ } 
+ break; 
+ 
+ /* Data Packets */ 
+ case MAUSB_PKT_TYPE_DATA: 
+ 
+ length = sizeof(struct mausb_dph); 
+ 
+ switch (pkt->common->pkt_type) { 
+ case TransferReq: 
+ case TransferResp: /* FALLTHROUGH */ 
+ if (mausb_pkt_has_setup_data(pkt->data)) 
+ length += sizeof(*pkt->setup); 
+ 
+ length += mausb_pkt_datafield_length(pkt); 
+ break; 
+ case TransferAck: 
+ break; 
+ case IsochTransferReq: 
+ case IsochTransferResp: /* FALLTHROUGH */ 
+ length = sizeof(struct mausb_iso_dph); 
+ length += mausb_pkt_datafield_length(pkt); 
+ 
+ break; 
+ default: 
+ mapkt_err("%s: invalid data packet type %x\n", __func__, 
+ pkt->common->pkt_type); 
+ BUG(); 
+ break; 
+ } 
+ break; 
+ 
+ default: 
+ mapkt_err("%s: invalid packet type %x\n", __func__, 
+ pkt->common->pkt_type); 
+ BUG(); 
+ break; 
+ } 
+ 
+ return length; 
+} 
+EXPORT_SYMBOL(mausb_pkt_length); 
+ 
+/** 
+ * Finds and returns the memory location offset a number of bytes from a 
+ * CapResp packet. Used to find or place device capability descriptors in 
+ * a CapResp packet. 
+ */ 
+struct mausb_dev_cap_desc *cap_desc_ptr_increment(struct mausb_mgmt_pkt *resp, 
+ int offset) 
+{ 
+ struct mausb_dev_cap_desc *desc; 
+ char *temp; 
+ 
+ temp = (char *) resp; 
+ temp += offset; 
+ 
+ desc = (struct mausb_dev_cap_desc *) (temp); 
+ 
+ return desc; 
+} 
+EXPORT_SYMBOL(cap_desc_ptr_increment); 
+ 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_pkt.h linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_pkt.h
